"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockDeclaration = exports.MockDeclarations = void 0;
var common_1 = require("../common");
var mock_component_1 = require("../mock-component");
var mock_directive_1 = require("../mock-directive");
var mock_pipe_1 = require("../mock-pipe");
function MockDeclarations() {
    var declarations = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        declarations[_i] = arguments[_i];
    }
    return declarations.map(MockDeclaration);
}
exports.MockDeclarations = MockDeclarations;
function MockDeclaration(declaration) {
    if (common_1.isNgDef(declaration, 'p')) {
        return mock_pipe_1.MockPipe(declaration);
    }
    if (common_1.isNgDef(declaration, 'c')) {
        return mock_component_1.MockComponent(declaration);
    }
    if (common_1.isNgDef(declaration, 'd')) {
        return mock_directive_1.MockDirective(declaration);
    }
    return declaration;
}
exports.MockDeclaration = MockDeclaration;
//# sourceMappingURL=mock-declaration.js.map