import { Provider } from '@angular/core';
export declare type MockedFunction = () => any;
export declare const mockServiceHelper: {
    extractMethodsFromPrototype(service: any): string[];
    extractPropertiesFromPrototype(service: any): string[];
    extractPropertyDescriptor(service: any, prop: string): PropertyDescriptor | undefined;
    mock<T = MockedFunction>(instance: any, name: string, style: 'get' | 'set', mockName?: string): T;
    mock<T = MockedFunction>(instance: any, name: string, mockName?: string): T;
    mockFunction(mockName: string): MockedFunction;
    registerMockFunction(mockFunction: (mockName: string) => MockedFunction | undefined): void;
    replaceWithMocks(value: any): any;
    resolveProvider(def: Provider, resolutions: Map<any, any>, changed?: (flag: boolean) => void): Provider;
    useFactory<D, I>(def: D, instance: () => I): Provider;
};
export declare function MockService(service?: boolean | number | string | null, mockNamePrefix?: string): undefined;
export declare function MockService<T>(service: new (...args: any[]) => T, mockNamePrefix?: string): T;
export declare function MockService<T = any>(service: object, mockNamePrefix?: string): T;
